<template>
  <Breadcrump :title="$t('newUser')"></Breadcrump>
  <div class="row">
    <div class="col-12 col-lg-10 col-md-10">
      <div class="card">
        <div class="card-body">
          <form @submit.prevent="submit()">
            <div class="form-group row">
              <label for="example-text-input" class="col-sm-2 col-form-label">{{
                $t("name")
              }}</label>
              <div class="col-sm-10">
                <input
                  class="form-control"
                  type="text"
                  id="example-text-input"
                  v-model="userById.name"
                  :class="{ 'parsley-error': error.name }"
                />
                <ul
                  class="parsley-errors-list filled"
                  id="parsley-id-5"
                  v-if="error.name"
                >
                  <li
                    class="parsley-required"
                    v-for="(error, index) in error.name"
                    :key="index"
                  >
                    {{ error }}
                  </li>
                </ul>
              </div>
            </div>
            <div class="form-group row">
              <label for="example-text-input" class="col-sm-2 col-form-label">{{
                $t("email")
              }}</label>
              <div class="col-sm-10">
                <input
                  class="form-control"
                  type="text"
                  id="example-text-input"
                  v-model="userById.email"
                  :class="{ 'parsley-error': error.email }"
                />
                <ul
                  class="parsley-errors-list filled"
                  id="parsley-id-5"
                  v-if="error.email"
                >
                  <li
                    class="parsley-required"
                    v-for="(error, index) in error.email"
                    :key="index"
                  >
                    {{ error }}
                  </li>
                </ul>
              </div>
            </div>
            <div class="form-group row">
              <label for="example-text-input" class="col-sm-2 col-form-label">{{
                $t("password")
              }}</label>
              <div class="col-sm-10">
                <input
                  class="form-control"
                  type="password"
                  id="example-text-input"
                  v-model="userById.password"
                  :class="{ 'parsley-error': error.password }"
                />
                <ul
                  class="parsley-errors-list filled"
                  id="parsley-id-5"
                  v-if="error.password"
                >
                  <li
                    class="parsley-required"
                    v-for="(error, index) in error.password"
                    :key="index"
                  >
                    {{ error }}
                  </li>
                </ul>
                <small v-if="id">{{ $t("pass_info") }}</small>
              </div>
            </div>
            <div class="form-group row" v-if="role === 'Super Admin'">
              <label class="col-sm-2 col-form-label">{{ $t("role") }}</label>
              <div class="col-sm-10">
                <select
                  class="custom-select"
                  :class="{ 'parsley-error': error.role }"
                  v-model="userById.role"
                >
                  <option selected="" disabled>{{ $t("please") }}</option>
                  <option :value="role.id" v-for="role in roles" :key="role.id">
                    {{ role.name }}
                  </option>
                </select>
                <ul
                  class="parsley-errors-list filled"
                  id="parsley-id-5"
                  v-if="error.role"
                >
                  <li
                    class="parsley-required"
                    v-for="(error, index) in error.role"
                    :key="index"
                  >
                    {{ error }}
                  </li>
                </ul>
              </div>
            </div>
            <div class="form-group mb-0">
              <div class="button-items">
                <button
                  type="submit"
                  class="btn btn-primary waves-effect waves-light"
                >
                  <span
                    class="spinner-border spinner-border-sm"
                    role="status"
                    v-if="loading"
                    aria-hidden="true"
                  ></span>
                  {{ $t("save") }}
                </button>
                <router-link
                  :to="{ name: 'users' }"
                  class="btn btn-danger waves-effect m-l-5"
                >
                  {{ $t("cancel") }}
                </router-link>
              </div>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import Breadcrump from "../../components/Breadcrump.vue";
import { useUserStore } from "../../stores/users";
import { useAuthStore } from "../../stores/auth";
import { useRolesStore } from "../../stores/roles";
import { storeToRefs } from "pinia";
import { onMounted } from "vue";
import { RouterLink } from "vue-router";
3;
import router from "../../router";
const props = defineProps({
  id: Number,
});
const userStore = useUserStore();
const roleStore = useRolesStore();
const authStore = useAuthStore();
const { role, userId } = storeToRefs(authStore);
const { userById, error } = storeToRefs(userStore);
const { roles } = storeToRefs(roleStore);

const submit = async () => {
  console.log(userById.value);
  if (!props.id) {
    error.value = {};
    userStore.addUser(userById.value);
  } else {
    userStore.updateUser(userById.value, props.id);
  }
};
onMounted(() => {
  roleStore.fetchRole();
  if (props.id) {
    userStore.getUser(props.id);
  } else {
    userById.value = [];
  }
});
</script>

<style>
</style>